import { FaTagKind, DetectedSimpleTag, DetectedStackingTag } from "./TagDetector";
export declare abstract class FaTagBase {
    kind: FaTagKind;
    src: string | null;
    constructor(src: string | null, parsed: DetectedSimpleTag | DetectedStackingTag, _kind: FaTagKind);
    static detectFaTag(str: string, pos: number, ignoreStyled: boolean): FaTagBase | null;
}
export declare class SimpleFaTag extends FaTagBase {
    icons: string[];
    styles: string[];
    constructor(tag: string | null, parsed: DetectedSimpleTag | DetectedStackingTag);
    get hasStyle(): boolean;
    getIconsAsString(): string;
    getStylesAsString(removeComma: boolean): string;
    toString(): string;
    protected _setParsed(parsed: DetectedSimpleTag): void;
}
export declare class StackingFaTag extends FaTagBase {
    readonly children: SimpleFaTag[];
    constructor(src: string | null, parsed: DetectedSimpleTag | DetectedStackingTag);
    toString(): string;
    protected _setParsed(parsed: DetectedStackingTag): void;
}
