"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FaTagListRuleEngine = void 0;
const MarkdownItEngineBase_1 = require("./MarkdownItEngineBase");
const FaTagListTokenReplacer_1 = require("./FaTagListTokenReplacer");
class FaTagListRuleEngine extends MarkdownItEngineBase_1.MarkdownItEngineBase {
    jack(state, startLine, endLine, silent) {
        const newTokenStart = state.tokens.length;
        let ret = false;
        if (this.defaultListRule) {
            ret = this.defaultListRule(state, startLine, endLine, silent);
        }
        if (ret) {
            const newTokenEnd = state.tokens.length - 1;
            if (!silent) {
                const replacer = new FaTagListTokenReplacer_1.FaTagListTokenReplacer(state, { start: newTokenStart, end: newTokenEnd });
                replacer.replace();
            }
        }
        return ret;
    }
    use() {
        this.defaultListRule = this._getDefaultListRule();
        this._md.block.ruler.at('list', (state, startLine, endLine, silent) => {
            return this.jack(state, startLine, endLine, silent);
        }, { alt: ['paragraph', 'reference', 'blockquote'] });
    }
    _getDefaultListRule() {
        for (const rule of this._md.block.ruler.getRules('')) {
            if (rule.name === 'list') {
                return rule;
            }
        }
        return null;
    }
}
exports.FaTagListRuleEngine = FaTagListRuleEngine;
