"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FaTagRuleEngine = void 0;
const FontawesomeOption_1 = require("./FontawesomeOption");
const FaTagTokenizer_1 = require("./FaTagTokenizer");
const MarkdownItEngineBase_1 = require("./MarkdownItEngineBase");
class FaTagRuleEngine extends MarkdownItEngineBase_1.MarkdownItEngineBase {
    rule(state, silent) {
        var detected = false;
        var tokenizer = FaTagTokenizer_1.FaTokenizerBase.createTokenizer(state, silent, this._option ?? FontawesomeOption_1.DefaultOption);
        if (tokenizer !== null) {
            detected = true;
            tokenizer.run();
        }
        return detected;
    }
    use() {
        this._md.inline.ruler.push('fontawesome_tag', (state, silent) => {
            return this.rule(state, silent);
        });
    }
}
exports.FaTagRuleEngine = FaTagRuleEngine;
