import StateInline from "markdown-it/lib/rules_inline/state_inline";
import { FontawesomeOption } from "./FontawesomeOption";
import { FaTagBase, SimpleFaTag, StackingFaTag } from './FaTag';
export declare abstract class FaTokenizerBase<T extends FaTagBase> {
    _stateInline: StateInline;
    _silent: boolean;
    _faTag: T;
    constructor(stateInline: StateInline, silent: boolean, detectedTag: T);
    protected _pushStackingTag(stackingTag: StackingFaTag): void;
    protected _pushFaTag(fatag: SimpleFaTag): void;
    protected abstract _tokenize(): void;
    run(): void;
    static createTokenizer(state: StateInline, silent: boolean, option: FontawesomeOption): FaTokenizerBase<SimpleFaTag | StackingFaTag> | null;
}
export declare class FaTagTokenizer extends FaTokenizerBase<SimpleFaTag> {
    protected _tokenize(): void;
}
export declare class StackingTokenizer extends FaTokenizerBase<StackingFaTag> {
    protected _tokenize(): void;
}
