/**
 * Regular Expression for Fontawesome-Tag
 */
export declare const FaTagRegEx: {
    hyphenConnectedAlpha: string;
    simpleFaTag: string;
    styledFaTag: string;
    faTag: string;
    simpleStackingFaTag: string;
    stackingFaTag: string;
};
/**
 * The kinds of Fontawesome tags
 */
export declare type FaTagKind = "simple" | "stacking";
/**
 * result of detector.
 */
export interface DetectedFaTag {
    kind: FaTagKind;
    tag: string;
    parsed: DetectedSimpleTag | DetectedStackingTag;
}
export interface DetectedSimpleTag {
    faClasses: string;
    styleClasses: string | null;
}
export declare type DetectedStackingTag = DetectedSimpleTag[];
export declare function _detectSimpleTag(source: string, ignoreStyled: boolean): DetectedFaTag | null;
export declare function _detectStackingTag(source: string, ignoreStyled: boolean): DetectedFaTag | null;
