"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FaTagRuleEngine = void 0;
const FaTagTokenizer_1 = require("./FaTagTokenizer");
const FaTagRuleEngineBase_1 = require("./FaTagRuleEngineBase");
class FaTagRuleEngine extends FaTagRuleEngineBase_1.FaTagRuleEngineBase {
    rule(state, silent) {
        var detected = false;
        var tokenizer = (0, FaTagTokenizer_1.createTokenizer)(state, silent, this._option);
        if (tokenizer !== null) {
            detected = true;
            tokenizer.run();
        }
        return detected;
    }
    use() {
        this._md.inline.ruler.push('fontawesome_tag', (state, silent) => {
            return this.rule(state, silent);
        });
    }
}
exports.FaTagRuleEngine = FaTagRuleEngine;
